import { InjectionToken } from '@angular/core';
export declare const ELEMENTS_ICONS: InjectionToken<ElementsIcon[]>;
export declare const ELEMENTS_ERRORS: InjectionToken<ElementsError[]>;
export declare type ElementsIcon = ElementsIconFont | ElementsIconImage | ElementsIconUnknown;
export declare type ElementsError = {
    [error: string]: (data?: any) => string | {
        token: string;
        data?: any;
    };
};
export interface ElementsIconFont {
    namespace: string;
    className: string;
    inline?: boolean;
    type: 'font';
}
export interface ElementsIconImage {
    namespace: string;
    name: string;
    src: string;
    type: 'image';
}
export interface ElementsIconUnknown {
    type: 'unknown';
}
